#property indicator_chart_window

extern string  TimeFrame                  = "Current time frame";
extern bool		NoRepaint					   = FALSE;
extern double	MinorMinExtremeHeightATRs	= 2.0;
extern double	MajorToMinorHeightRatio		= 2.5;
extern int		MinorMinExtremeWidth		   = 2;
extern int		MajorMinExtremeWidth		   = 2;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{ 
   timeFrame = stringToTimeFrame(TimeFrame); return(0); 
}
int start()
{
   Comment("");   
   double valueUp = 0;
   double valueDn = 0;
   
   for (int i=0; i<Bars; i++)
   {
      double value = iCustom(NULL,timeFrame,"Extreme_Spike",NoRepaint,MinorMinExtremeHeightATRs,MajorToMinorHeightRatio,MinorMinExtremeWidth,MajorMinExtremeWidth,4,i);
            if (value!=0)
            {
               valueUp = iCustom(NULL,timeFrame,"Extreme_Spike",NoRepaint,MinorMinExtremeHeightATRs,MajorToMinorHeightRatio,MinorMinExtremeWidth,MajorMinExtremeWidth,0,i);
               valueDn = iCustom(NULL,timeFrame,"Extreme_Spike",NoRepaint,MinorMinExtremeHeightATRs,MajorToMinorHeightRatio,MinorMinExtremeWidth,MajorMinExtremeWidth,1,i);
                  if (valueUp != 0 || valueDn!=0) break;
            }
   }                      
   if (valueUp!=0) Comment("last peak is SELL and it happend at bar : "+i+" of "+timeFrameToString(timeFrame)+" time frame");
   if (valueDn!=0) Comment("last peak is BUY and it happend at bar : "+i+" of "+timeFrameToString(timeFrame)+" time frame");
   return(0);
}

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}